<?php
/**
 * WoWRoster.net WoWRoster
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @copyright  2012 WoWRoster.de
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: index.php 2.3.0 2012-11-22 17:31:20Z webmaster@wowroster.de $
 * @link       http://www.wowroster.de
 * @package    Characters Notes
 * @subpackage addon
*/

if ( !defined('IN_ROSTER') ) exit('Detected invalid access to this file!');

require_once($addon['inc_dir'].$addon['basename'].'.class.php');

$content = null;
$cn = new characters_notes();
$action = $cn->get_param('action', 'REQUEST', 'string', false);
$char_id = ($roster->atype == 'char') ? $roster->anchor : null;
if (!isset($action) || empty($action)) $action = 'default';
switch($action)
{
    default:
        $roster->tpl->set_filenames(array('notes' => $addon['basename'].'/notes.html'));
        $roster->tpl->display('notes');        
        break;  
              
    case 'change_status':
        if (isset($char_id) && !empty($char_id))
        {
            $nid = $cn->get_param('nid', 'REQUEST', 'integer', false);
            $status = $cn->get_param('status', 'REQUEST', 'integer', false);
            $cn->change_status($char_id, $nid, $status);
        } 
        else $content = $roster->locale->act['no_character_selected'];
        break;    
    case 'get_xml_notes':        
        if (isset($char_id) && !empty($char_id))
        {
            $where = "`char_id` = '".(int)$roster->db->escape($char_id)."' ORDER BY `date_added` DESC";
            $cn->get_xml('data', array('note_id', 'title', 'note', 'status_id'), $where, 'characters_notes');
        }
        break;    
    case 'get_xml_note':
        $note_id = $cn->get_param('note_id', 'REQUEST', 'integer', false);
        if (isset($char_id) && !empty($char_id) && isset($note_id) && !empty($note_id))
        {
            $where = "`char_id` = '".(int)$roster->db->escape($char_id)."' AND `note_id` = '".(int)$roster->db->escape($note_id)."'";
            $cn->get_xml('data', array('note_id', 'title', 'note', 'status_id'), $where, 'characters_notes');
        }
        else
        {
            $content = '<ul>'."\n";
            if (!isset($char_id) || empty($char_id)) $content .= '  <li>'.$roster->locale->act['no_character_selected'].'</li>';
            if (!isset($note_id) || empty($note_id)) $content .= '  <li>'.$roster->locale->act['no_note_selected'].'</li>';
            $content .= '</ul>'."\n";
        }
        break;
    case 'add_note':
        $cn->no_roster_output();
        if (isset($char_id) && !empty($char_id))
        {
            $note_title = $cn->get_param('title', 'REQUEST', 'string', false);
            $note_text = $cn->get_param('text', 'REQUEST', 'string', false);
            if (isset($note_title) && !empty($note_title) && isset($note_text) && !empty($note_text))
                $cn->add_note($char_id, $note_title, $note_text);
            else
            {
                $content .= '<ul>'."\n";
                if (!isset($note_title) || empty($note_title)) $content .= '<li>'.$roster->locale->act['no_title'].'</li>'."\n";
                if (!isset($note_text) || empty($note_text)) $content .= '<li>'.$roster->locale->act['no_text'].'</li>'."\n";   
                $content .= '</ul>'."\n";         
            }
        }
        else
            $content = $roster->locale->act['no_character_selected'];
        break;    
    case 'edit_note':
        $cn->no_roster_output();
        $note_id = $cn->get_param('note_id', 'REQUEST', 'integer', false);
        if (isset($note_id) && !empty($note_id))
            $cn->edit_note($note_id, $note_title, $note_text, $note_status);
        else
            $content = $roster->locale->act['no_notice_selected'];    
        break;
    case 'delete_note':
        $cn->no_roster_output();
        $note_id = $_REQUEST['note_id'];
        if (isset($note_id) && !empty($note_id))
            $cn->delete_note($note_id);
        else
            $content = $roster->locale->act['no_notice_selected'];    
        break;    
}