<?php
/**
 * WoWRoster.net WoWRoster
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @copyright  2012 WoWRoster.de
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: install.def.php 0003 2012-05-14 19:13:20Z webmaster@wowroster.de $
 * @link       http://www.wowroster.de
 * @package    Characters Notes
 * @subpackage addon
*/

if ( !defined('IN_ROSTER') )
{
    exit('Detected invalid access to this file!');
}

/**
* Main addon class
*
* @package    Character Notes
* @subpackage addon
*/
class characters_notes
{
    private $_roster = null;
    private $_addon = null;
    private $_status = array();
    private $_statuslist = array();
   
    function __construct()
    {
        global $roster, $content;
        $this->load_status_messages();
        $this->build_start_js();  
        $this->load_tpl_localization();
    }
    
    function load_status_messages() 
    {
        global $roster;
        $sql = "SELECT * FROM `".$roster->db->table('status', 'characters_notes')."`";
        $res = $roster->db->query($sql);
        while ($data = $roster->db->fetch($res, MYSQL_ASSOC))
        {
            $this->_statuslist += array($data['status_id'] => $roster->locale->act[$data['status_name']]);
            $roster->tpl->assign_block_vars('status_options', array('ID' => $data['status_id'], 'NAME' => $roster->locale->act[$data['status_name']]));
        }              
    }  
   
    function add_note($cid, $title, $text)
    {
        global $roster, $content;
        $uid = $roster->auth->uid;
        $sql = "SELECT * FROM `".$roster->db->table('data', 'characters_notes')."` WHERE `uid_added` = '".(int)$uid."' AND `title` = '".$roster->db->escape($title)."' AND `note` = '".$roster->db->escape($text)."' AND `char_id` = '".(int)$cid."';";
        $res = $roster->db->query($sql);
        if ($roster->db->num_rows($res) == 0)
        {        
            $sql = "INSERT INTO `".$roster->db->table('data', 'characters_notes')."` 
                    (`char_id`, `uid_added`, `date_added`, `title`, `note`, `status_id`) 
                    VALUES ('".(int)$cid."', '".$uid."', '".date('U')."', '".$roster->db->escape($title)."', '".$roster->db->escape($text)."', 1);";
            if ($roster->db->query($sql)) $content = $roster->locale->act['notice_saved'];
            else $content = $roster->locale->act['notice_not_saved'];
        }
        else $content = $roster->locale->act['notice_exists'];
    }

    function delete_note($note_id)
    {
        global $roster, $content;
        $sql = "DELETE FROM `".$roster->db->table('data', 'characters_notes')."` WHERE `note_id` = ".(int)$roster->db->escape($note_id).";";
        if ($roster->db->query($sql)) $content = $roster->locale->act['notice_deleted'];
        else $content = $roster->locale->act['notice_not_deleted']; 
    }
    function edit_note($note_id, $title = null, $text = null, $status = null)
    {
        global $roster, $content;
        $title = $this->get_param('title', 'REQUEST', 'string', false);
        $text = $this->get_param('text', 'REQUEST', 'string', false);
        $status = $this->get_param('status', 'REQUEST', 'integer', false);        
        $note_id = (int)$note_id;
        $status = (int)$status; // Status is always a integer
        $text = str_replace('\n', '<br />', nl2br($text));
        $uid = $roster->auth->uid;
        $sql = "UPDATE `".$roster->db->table('data', 'characters_notes')."` SET ";
        if (isset($title) && !empty($title)) $sql .= "`title` = '".$roster->db->escape($title)."', ";
        if (isset($text) && !empty($text)) $sql .= "`note` = '".$roster->db->escape($text)."', ";
        if (isset($status) && !empty($status)) $sql .= "`status_id` = ".(int)$roster->db->escape($status).", ";
        $sql .= " `uid_last_edit` = ".(int)$roster->db->escape($uid).", ";
        $sql .= " `date_last_edit` = ".date('U');
        $sql .= " WHERE `note_id` = ".(int)$roster->db->escape($note_id).";";        
        $res = $roster->db->query($sql);
        if ($roster->db->query($sql)) $content = $roster->locale->act['notice_edited'];
        else $content = $roster->locale->act['notice_not_edited'];
    }
    
    function get_username($uid)
    {
        global $roster;
        $sql = "SELECT * FROM `".$roster->db->table('user_members')."` WHERE `id` = '".$roster->db->escape($uid)."';";
        $res = $roster->db->query($sql);
        $data = $roster->db->fetch($res, MYSQL_ASSOC);
        return $data['usr'];
    }

    function debug_out($text)
    {
        global $content;
        $content .= '<div class="ui-widget-header ui-corner-top" style="padding:5px;">Debug Output</div><div class="ui-widget-content ui-corner-bottom" style="padding:5px;">'.$text.'</div>'."\n";
    }
    
    function change_status($cid, $nid, $status)
    {
        global $roster;
        $sql = "UPDATE `".$roster->db->table('data', 'characters_notes')."` SET `status_id` = '".(int)$roster->db->escape($status)."' WHERE `char_id` = '".(int)$roster->db->escape($cid)."' AND `note_id` = '".(int)$roster->db->escape($nid)."';";
        if ($roster->db->query($sql)) return true;
        else return false;        
    }
   
    function createOptionList( $values , $selected , $id , $type='' , $param='' )
    {
        if( !empty($selected) ) $select_one = true;
        $option_list = "\n   <select id=\"{$id}\" name=\"{$id}\" $param>\n";
        foreach( $values as $Aname => $Avalue )
        {
            switch ($type)
            {
                case 0: // name value
                case 'list':
                    $value = $Avalue;
                    $name = $Aname;
                    break;
                case 1: // value name                
                case 'rev':
                    $value = $Aname;
                    $name = $Avalue;
                    break;
                case 2: // name name
                case 'name':
                    $value = $Aname;
                    $name = $Aname;
                    break;
                case 3: // value value
                case 'value':
                    $value = $Avalue;
                    $name = $Avalue;
                break;
                default:
                    $value = $Avalue;
                    $name = $Aname;
                    break;
            }
            if( $selected == $value && $select_one )
            {
                $option_list .= "   <option value=\"{$value}\" selected=\"selected\">{$name}</option>\n";
                $select_one = false;
            }
            else
                $option_list .= "   <option value=\"{$value}\">{$name}</option>\n";
        }
        $option_list .= "   </select>";
        return $option_list;
    }
    
    function build_start_js()
    {
        global $roster, $addon;
        $tmp_url = str_replace('&amp;', '&', makelink('char-characters_notes&action=get_xml_notes', false));
        $tmp = explode('?', $tmp_url);
        $js_start = '<script type="text/javascript">'."\n";
        $js_start .= '   var baseurl = "'.$tmp[0].'";'."\n";
        $js_start .= '   var addonname = "'.$addon['basename'].'";'."\n";
        $js_start .= '   var cid = '.(($roster->atype == 'char') ? $roster->anchor : 'null').';'."\n";
        $js_start .= '   var locals = new Array();'."\n";
        $js_start .= '   var status_locals = new Array();'."\n";
        $js_start .= '   var jq_effect = "'.$addon['config']['characters_notes_jquery_effect'].'";'."\n";
        $js_start .= '   var jq_effect_duration = "'.$addon['config']['characters_notes_jquery_effect_duration'].'";'."\n";
        foreach ($roster->locale->act['cn_js'] as $index => $data)
            $js_start .= '   locals["'.$index.'"] = "'.$data.'";'."\n";
        foreach ($this->_statuslist as $id => $text)
            $js_start .= '   status_locals['.$id.'] = "'.$text.'";'."\n";
        if($roster->auth->getAuthorized( $addon['config']['characters_notes_edit_access'] ) )
            $js_start .= '   var allow_edit = true;'."\n";
        else 
            $js_start .= '   var allow_edit = false;'."\n";
        $js_start .= '   get_char_notes('.(($roster->atype == 'char') ? $roster->anchor : 'null').',"'.$tmp[0].'","'.$addon['basename'].'");'."\n";
        $js_start .= '   $(\'#auto_stop\').hide();'."\n";
        $js_start .= '   $(\'#messages\').hide();'."\n";
        $js_start .= '</script>'."\n";        
        $roster->tpl->assign_var('js_start', $js_start);
        unset($tmp);
    }
    
    function load_tpl_localization()
    {
        global $roster, $addon;
        $tmp_url = str_replace('&amp;', '&', makelink('char-characters_notes&action=get_xml_notes', false));
        $tmp = explode('?', $tmp_url);
        $roster->tpl->assign_var('baseurl', $tmp[0]);
        $roster->tpl->assign_var('char_id', (($roster->atype == 'char') ? $roster->anchor : null) );
        $roster->tpl->assign_var('addon_name', $addon['basename']);
        $tmp = makelink($addon['basename']);
        $tmp = explode('?', $tmp);
        $roster->tpl->assign_var('baseurl', $tmp[0]);
        unset($tmp);
        // check if allowed to change / add  / delete notes
        if($roster->auth->getAuthorized( $addon['config']['characters_notes_edit_access'] ) )
            $roster->tpl->assign_var('ALLOW_NEW_NOTE', true);
        else $roster->tpl->assign_var('ALLOW_NEW_NOTE', null);
        foreach ($roster->locale->act['cn_tpl'] as $index => $data) $roster->tpl->assign_var($index, $data);
        $values['5 '.$roster->locale->act['seconds']] = 5000;
        $values['10 '.$roster->locale->act['seconds']] = 10000;
        $values['30 '.$roster->locale->act['seconds']] = 30000;
        $values['1 '.$roster->locale->act['minutes']] = 60000;
        $values['5 '.$roster->locale->act['minutes']] = 300000;
        $values['10 '.$roster->locale->act['minutes']] = 600000;
        $roster->tpl->assign_var('select_duration', $this->createOptionList($values,$addon['config']['characters_notes_auto_durations'], 'refresh_timeout'));
    }
    
    function get_param($param, $url_type = 'REQUEST', $param_type = 'string', $password = false)
    {
        switch($url_type)
        {
            default:
                // REQUEST
                if (isset($_REQUEST[$param]) && !empty($_REQUEST[$param]))
                {                
                    switch($param_type)
                    {
                        default:
                            // string
                            if ($password == false) return $_REQUEST[$param];
                            else return md5($_REQUEST[$param]);
                            break;                    
                        case 'integer':
                        case 'int':
                            // integer
                            if ($password == false) return intval($_REQUEST[$param]);
                            else return md5(intval($_REQUEST[$param]));
                            break;                    
                        case 'array':
                            // array
                            return (array)$_REQUEST[$param];
                            break;                   
                        case 'object':
                            // object
                            return (object)$_REQUEST[$param];
                            break;
                        case 'sql':
                            // sql string
                            if ($password == false) return $roster->db->escape($_REQUEST[$param]);
                            else return md5($roster->db->escape($_REQUEST[$param]));
                            break;
                    } 
                }
                else return null;           
                break;
            case 'GET':
                // GET
                if (isset($_GET[$param]) && !empty($_GET[$param]))
                {                
                    switch($param_type)
                    {
                        default:
                            // string
                            if ($password == false) return $_GET[$param];
                            else return md5($_GET[$param]);
                            break;                    
                        case 'integer':
                        case 'int':
                            // integer
                            if ($password == false) return intval($_GET[$param]);
                            else return md5(intval($_GET[$param]));
                            break;                    
                        case 'array':
                            // array
                            return (array)$_GET[$param];
                            break;                   
                        case 'object':
                            // object
                            return (object)$_GET[$param];
                            break;
                        case 'sql':
                            // sql string
                            if ($password == false) return $roster->db->escape($_GET[$param]);
                            else return md5($roster->db->escape($_GET[$param]));
                            break;
                    }
                }
                else return null;            
                break;
            case 'POST':
                // GET
                if (isset($_POST[$param]) && !empty($_POST[$param]))
                {                
                    switch($param_type)
                    {
                        default:
                            // string
                            if ($password == false) return $_POST[$param];
                            else return md5($_POST[$param]);
                            break;                    
                        case 'integer':
                        case 'int':
                            // integer
                            if ($password == false) return intval($_POST[$param]);
                            else return md5(intval($_POST[$param]));
                            break;                    
                        case 'array':
                            // array
                            return (array)$_POST[$param];
                            break;                   
                        case 'object':
                            // object
                            return (object)$_POST[$param];
                            break;
                        case 'sql':
                            // sql string
                            if ($password == false) return $roster->db->escape($_POST[$param]);
                            else return md5($roster->db->escape($_POST[$param]));
                            break;
                    }   
                }
                else return null;         
                break;            
        }
    }
    
    function no_roster_output()
    {
        global $roster;
        $roster->output['show_header'] = false;  // Disable the roster header
        $roster->output['show_menu'] = false;    // Disable roster menu
        $roster->output['show_footer'] = false;  // Disable roster footer    
    }  

    function fetch_db_data($table, $fields = '*', $where = null, $addon = null)
    {
        global $roster;
        $sql = 'SELECT';
        if ($fields === '*') $sql .= ' * ';
        elseif (is_array($fields) && !empty($fields) && sizeof($fields) > 0) 
        {
            foreach ($fields as $field) $sql .= ' `'.$field.'`, ';
            $sql = trim($sql, ', ');            
        }
        $sql .= ' FROM `'.$roster->db->table($table, $addon).'`';
        if (isset($where) && !empty($where))
        $sql .= ' WHERE '.$where.';';
        $res = $roster->db->query($sql);
        while ($data = $roster->db->fetch($res))
        {
            foreach ($fields as $field) $tmp[$field] = $data[$field];
            $this->_data[] = $tmp;
            unset($tmp);
        } 
    }
    
    function build_xml()
    {
        if (is_array($this->_data) && !empty($this->_data) && sizeof($this->_data) > 0)
        {
            $this->_xml = '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'."\n";
            $this->_xml .= '<!DOCTYPE data ['."\n";
            $this->_xml .= '   <!ELEMENT data (entrie*)>'."\n";
            $this->_xml .= '   <!ELEMENT entrie (';
            foreach ($this->_data[0] as $fieldname => $fielddata) $this->_xml .=        $fieldname.',';
            $this->_xml = trim(trim($this->_xml, ','));
            $this->_xml .= ')>'."\n";
            foreach ($this->_data[0] as $fieldname => $fielddata) $this->_xml .= '   <!ELEMENT '.$fieldname.' (#PCDATA)>'."\n";
            $this->_xml .= ']>'."\n";
            $this->_xml .= '<data>'."\n";
            foreach ($this->_data as $id => $data)
            {
                $this->_xml .= '   <entrie>'."\n";
                foreach ($data as $fieldname => $fielddata) $this->_xml .= '       <'.$fieldname.'><![CDATA['.$fielddata.']]></'.$fieldname.'>'."\n";
                $this->_xml .= '   </entrie>'."\n";
            }
            $this->_xml .= '</data>'."\n";
        }
        else 
        {
            $this->_xml = null;
        }
     }
     
     function get_xml($table, $fields = '*', $where = null, $addon = null)
     {
        global $roster, $content;
        $roster->output['show_header'] = false;  // Disable the roster header
        $roster->output['show_menu'] = false;    // Disable roster menu
        $roster->output['show_footer'] = false;  // Disable roster footer     
        $this->fetch_db_data($table, $fields, $where, $addon);
        $this->build_xml();
        $content = $this->_xml;
     }

}