<?php
/**
 * WoWRoster.net WoWRoster
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @copyright  2012 WoWRoster.de
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: install.def.php 0003 2012-06-02 00:38:20Z webmaster@wowroster.de $
 * @link       http://www.wowroster.de
 * @package    Characters Notes
 * @subpackage Installer
*/

if ( !defined('IN_ROSTER') )
{
    exit('Detected invalid access to this file!');
}

/**
 * Installer Character Notes
 *
 * @package    Character Notes
 * @subpackage Installer
 */
class characters_notesInstall
{
	var $active = true;
	var $icon = 'inv_misc_book_03';

	var $version = '2.3.0';	// ALWAYS NOTE BELOW IN upgrade() WHY THE VERSION NUMBER HAS CHANGED, EVEN WHEN ONLY UPDATING KEY DEFINES
	var $wrnet_id = '';

	var $fullname = 'characters_notes';
	var $description = 'characters_notes_desc';
	var $credits = array(
		array(	"name"=>	"Joerg Hufen, 2012",
				"info"=>	"Adding notes to a character like \"on holiday for 2 weeks\"")
	);


	/**
	 * Install Function
	 *
	 * @return bool
	 */
	function install()
	{
		global $installer;

		// Master and menu entries
		$installer->add_menu_button('characters_notesbutton','char');
		$installer->add_config("'1','startpage','characters_notes_conf','display','master'");
		$installer->add_config("'110','characters_notes_conf',NULL,'blockframe','menu'");
		$installer->add_config("'1010','characters_notes_edit_access','11:1','access','characters_notes_conf'");
        $installer->add_config("'1020', 'characters_notes_jquery_effect', 'blind', 'select{None^null|Blind^blind|Bounce^bounce|Clip^clip|Drop^drop|Explode^explode|Fold^fold|Highlight^hightlight|Puff^puff|Pulsate^pulsate|Scale^scale|Shake^shake|Size^size|Slide^slide', 'characters_notes_conf'");
        $installer->add_config("'1030', 'characters_notes_jquery_effect_duration', '500', 'text{6|10', 'characters_notes_conf'");
        $installer->add_config("'1040', 'characters_notes_auto_durations', '300000', 'select{5000^5s|10000^10s|30000^30s|60000^1m|300000^5m|600000^10m', 'characters_notes_conf'");
 		$installer->create_table($installer->table('data'),"
  					`note_id` INT(10) AUTO_INCREMENT NOT NULL,
					`char_id` int(11) NOT NULL,
  					`uid_added` INT(11) NOT NULL,
  					`uid_last_edit` INT(11) NOT NULL,
  					`date_added` INT(20) NOT NULL,
  					`date_last_edit` INT(20) default NULL,
                    `title` VARCHAR(155) NOT NULL,
  					`note` TEXT default NULL,
  					`status_id` TINYINT(1) NOT NULL,
  					KEY `note_id` (`note_id`)");
        $installer->create_table($installer->table('status'),"
                    `status_id` TINYINT(1) AUTO_INCREMENT NOT NULL,
                    `status_name` VARCHAR(255) NOT NULL,
                    `status_color` VARCHAR(7) NOT NULL,
                    KEY `status_id` (`status_id`)");
        $installer->add_query("INSERT INTO `".$installer->table('status')."` (`status_name`, `status_color`) VALUES
                    ('cn_notice', '#FFFFFF'), ('cn_warning', '#FF0000'), ('cn_open', '#FFFF00'), ('cn_close', '#00FF00')"); 
        return true;
	}

	/**
	 * Upgrade Function
	 *
	 * @param string $oldversion
	 * @return bool
	 */
	function upgrade($oldversion)
	{
		global $installer;
		if( version_compare('1.0.0.0001', $oldversion,'>') == true ) 
        {
    		$installer->add_config("'1','startpage','characters_notes_conf','display','master'");
    		$installer->add_config("'110','characters_notes_conf',NULL,'blockframe','menu'");
    		$installer->add_config("'1010','characters_notes_edit_access','11:1','access','characters_notes_conf'");
            $installer->add_config("'1020', 'characters_notes_jquery_effect', 'blind', 'select{None^null|Blind^blind|Bounce^bounce|Clip^clip|Drop^drop|Explode^explode|Fold^fold|Highlight^hightlight|Puff^puff|Pulsate^pulsate|Scale^scale|Shake^shake|Size^size|Slide^slide', 'characters_notes_conf'");
            $installer->add_config("'1030', 'characters_notes_jquery_effect_duration', '500', 'text{6|10', 'characters_notes_conf'");
            $installer->add_config("'1040', 'characters_notes_auto_durations', '300000', 'select{5000^5s|10000^10s|30000^30s|60000^1m|300000^5m|600000^10m', 'characters_notes_conf'");            
        }
        if (version_compare('2.3.0', $olderversion, '>') == true)
            $installer->remove_menu_button('characters_notes_addbutton');            
		return true;
	}

	/**
	 * Un-Install Function
	 *
	 * @return bool
	 */
	function uninstall()
	{
		global $installer;
		$installer->remove_all_config();
		$installer->remove_all_menu_button();
		$installer->drop_table($installer->table('data'));
        $installer->drop_table($installer->table('status'));
		return true;
	}
}
